import QtQuick 2.12
import QtQuick.Window 2.12
import QtQuick.Controls 2.5
import QtQuick.Controls.Imagine 2.12
import QtQuick.Controls.Imagine.impl 2.12

Window {
    visible: true
    width: 640
    height: 480
    title: qsTr("Hello World")

    NinePatchImage {
        id: idNinePatchesImage
        anchors.centerIn: parent
        width: 300
        height: 300
        state: "normal"
        states: [
            State {
                name: "press"
                PropertyChanges {
                    target: idNinePatchesImage
                    // 9-patches
                    source: "qrc:/press.9.png"
                }
            },
            State {
                name: "focus"
                PropertyChanges {
                    target: idNinePatchesImage
                    // normal image
                    source: "qrc:/focus.png"
                }
            },
            State {
                name: "normal"
                PropertyChanges {
                    target: idNinePatchesImage
                    // normal image
                    source: "qrc:/normal.png"
                }
            }
        ]

        onSourceChanged: {
            console.log("source: " + source)
        }
        onProgressChanged: {
            console.log("progress: " + progress)
        }
    }

    MouseArea {
        anchors.fill: parent
        onPressed: {
            idNinePatchesImage.state = "press"
        }

        onReleased: {
            idNinePatchesImage.state = "normal"
        }

        onClicked: {
            idNinePatchesImage.state = "focus"
        }
    }
}
